import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

import '../../abg_utils.dart';

List<String> _callbackStack = [];
late Function(String) route;
late BuildContext buildContext;
late Function() redrawMainWindow;
String currentBase = "";
String currentHost = "";
String locale = "en";

String _getCallback(){
  if (_callbackStack.isEmpty)
    return "home";
  if (_callbackStack.length == 1)
    return "home";
  _callbackStack.removeLast();
  _debugPrintStack();
  return _callbackStack[_callbackStack.length-1];
}

goBack(){
  dprint("Navigator: goBack");
  route(_getCallback());
}

String currentScreen(){
  if (_callbackStack.isNotEmpty)
    return _callbackStack[_callbackStack.length-1];
  return "";
}

_debugPrintStack(){
  var _text = "";
  for (var item in _callbackStack)
    _text = "$_text | $item";
  dprint("_debugPrintStack = $_text");
}

drawState(String _val, Function(String) _route, BuildContext context, Function() redraw, String _locale){
  route = _route;
  buildContext = context;
  redrawMainWindow = redraw;
  locale = _locale;
  //
  var url = Uri.base.toString();
  dprint(url);
  // print(window.location.href);
  // print(Uri.base.path);
  // if (url.endsWith("main"))
  //   currentBase = url.substring(0, url.length-4);
  if (kIsWeb) {
    var index = url.lastIndexOf("#/");
    currentBase = url.substring(0, index + 2);
    currentHost = url.substring(0, index - 1);
    dprint(currentHost);
  }
  //
  dprint("Navigator: drawState - add route $_val");
  if (_callbackStack.isEmpty)
    _callbackStack.add(_val);
  else
  if (_callbackStack[_callbackStack.length-1] != _val)
    _callbackStack.add(_val);
  _debugPrintStack();
}

callbackStackRemoveLast(){
  if (_callbackStack.isNotEmpty)
    _callbackStack.removeLast();
}

callbackStackRemovePenultimate(){
  if (_callbackStack.length > 2)
    _callbackStack.removeAt(_callbackStack.length-2);
  _debugPrintStack();
}